#-*- coding:utf-8 -*-
#!/usr/bin/env python

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

from osv import osv,fields
from tools.translate import _
import pooler
import time
import unicodedata
import re
import datetime

class family_report_wizard(osv.osv_memory):
    _name = "family.report.wizard"
    _description = 'Wizard para generar REPORTE de carga familiar'
    
    
    def _get_age(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        lista =[]
        
        for i in range(101):
            lista.append((str(i),str(i)))
        return lista
        
    _columns = {

    'titulo': fields.char('Titulo', size=50),
    'sede_id': fields.many2one('hr.sede', 'Sede', required=True), 
    'nomina_id': fields.many2one('hr.payroll', 'Nómina'),
    'all_sede': fields.boolean(''),
    'all_edad': fields.boolean(''),
    'all_nomina': fields.boolean(''),
    'type_employee': fields.selection([
                ('', ''),
                ('empleado', 'Empleado'),
                ('obrero', 'Obrero'),
                ('vendedor', 'Vendedor'),
            ], 'Tipo trabajador', select=True),
    'relationship': fields.selection(
                    [('', ''),
                    ('hijo_a', 'Hijo(a)'),
                    ('padre/madre', 'Padre/Madre'),
                    ('esposo_a', 'Esposo(a)'),
                    ('concubino_a', 'Concubino(a)'),], 'Parentesco'),
    'hcm': fields.boolean('HCM'),
    'seg_vida': fields.boolean('Seguro de Vida'),
    'edadd': fields.selection(_get_age, "Edad-Desde", 
          required=False, size=64),
    'edadh': fields.selection(_get_age, "Edad-Hasta", 
          required=False, size=64),
    
    }
    _defaults = {
        'all_sede': True, 'all_nomina':True, 'hcm': True, 'all_edad' :True,
    }
    

    def generar_reporte_carga_familiar(self, cr, uid, ids, context=None):
        
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        
        sede_id = [brw.sede_id.id]
        nomina_id = [brw.nomina_id.id]
        
        all_edad = brw.all_edad
        all_sede = brw.all_sede
        all_nomina = brw.all_nomina
        
        
        if all_sede:
            sede_id = self.pool.get('hr.sede').search(cr, uid, [])
        if all_nomina:
            nomina_id =  self.pool.get('hr.payroll').search(cr, uid, [])

        obj_employee = self.pool.get('hr.employee')
        obj_employee_departament = self.pool.get('hr.department')
        
        titulo = brw.titulo
        if not titulo:
            titulo = " "
            
        hcm = brw.hcm
        seg_vida = brw.seg_vida
        relationship = brw.relationship
        type_employee = brw.type_employee
        
        edadd = brw.edadd
        edadh = brw.edadh
        
        if edadd == False:
            edadd = 1000
        if edadh == False:
            edadh = 1000
        
        if all_edad != True:
            
            if ((edadd != False) and (edadh != False)):
                if edadd == 1000:
                    edadd = 0
                if edadh == 1000:
                    edadh = 0
                if int(edadh) < int(edadd):
                        raise osv.except_osv(_('ERROR!'), _('Edad-Desde no puede ser mayor a Edad-Hasta!!!'))
        
        if edadd == 0:
            edadd = 1000
        if edadh == 0:
            edadh = 1000

        if type_employee == False: 
                employee_id = obj_employee.search(cr, uid, [('hr_sede_id','in', sede_id),('hr_payroll_id', 'in', nomina_id),('state', '!=', 'egresado')])
        else:
                employee_id = obj_employee.search(cr, uid, [('hr_sede_id','in', sede_id),('hr_payroll_id', 'in', nomina_id),('type_employee','=', type_employee),('state', '!=', 'egresado')])
        
        
        departament_id = obj_employee_departament.search(cr, uid,[])
        departament_id_brw = obj_employee_departament.browse(cr ,uid, departament_id)
        
        browse_id = obj_employee.browse(cr, uid, employee_id)
        acumulador = {}
        
        for i in departament_id_brw:
            carga=[]
            acumulador[i.name] = [{p.id:self.familiares(p.id,relationship, edadd,edadh, hcm, seg_vida, all_edad)} for p in i.member_ids for n in browse_id if n.id == p.id]
            
            if acumulador[i.name] == []:
                del acumulador[i.name]
            else:                            
                for l in acumulador[i.name]:
                    for n in l:
                        if l[n]:
                            carga.append(l)
                    acumulador[i.name] = carga
                if acumulador[i.name] == []:
                    del acumulador[i.name]
        data={}
        if acumulador:
            data['form'] = acumulador
            data['titulo'] = titulo.upper()
        else:
            raise osv.except_osv(_('ERROR!'), _('la combinacion para generar dicho reporte no arrojo ningun resultado!!!'))
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'sisb.familiares',
            'datas':data, 
            }
               
    def familiares(self,employee_id, relationship, edadd, edadh, hcm, seg_vida, check):
        
        lista = []        
        obj_employee_family = self.pool.get('hr.employee.family')
        
        if check != True:
                
                if relationship and edadd  and edadh:
                    if edadd == 1000 and edadh == 1000:
                        employee_family_id = obj_employee_family.search(self.cr, self.uid, [('employee_id','=', employee_id),('hcm','=', hcm), ('seg_vida','=', seg_vida),('edad','>=', 0), ('edad','<=', 1), ('relationship','=',relationship)])   
                    else:
                        if edadd == 1000:
                            edadd = 0
                        edadh = int(edadh) + 1
                        employee_family_id = obj_employee_family.search(self.cr, self.uid, [('employee_id','=', employee_id),('hcm','=', hcm), ('seg_vida','=', seg_vida),('edad','>=', edadd), ('edad','<=', edadh), ('relationship','=',relationship)])   
           
            
                elif not relationship and edadd and edadh:
                    if edadd == 1000 and edadh == 1000:
                        employee_family_id = obj_employee_family.search(self.cr, self.uid, [('employee_id','=', employee_id),('hcm','=', hcm), ('seg_vida','=', seg_vida),('edad','>=', 0), ('edad','<=', 1)])   
                    else:
                        if edadd == 1000:
                            edadd = 0
                        edadh = int(edadh) + 1
                        employee_family_id = obj_employee_family.search(self.cr, self.uid, [('employee_id','=', employee_id),('hcm','=', hcm), ('seg_vida','=', seg_vida),('edad','>=', edadd), ('edad','<=', edadh)])   
        else:
                if not relationship:
                    employee_family_id = obj_employee_family.search(self.cr, self.uid, [('employee_id','=', employee_id),('hcm','=', hcm), ('seg_vida','=', seg_vida)])   

                if relationship:                    
                    employee_family_id = obj_employee_family.search(self.cr, self.uid, [('employee_id','=', employee_id),('hcm','=', hcm), ('seg_vida','=', seg_vida), ('relationship','=',relationship)])   
                
        family_brw = obj_employee_family.browse(self.cr ,self.uid, employee_family_id)
        
        for i in family_brw:
            if i.gender == 'female':
                genero = 'Femenino'
                if i.relationship == 'esposo_a':
                    parentesco = 'Esposa'
                if i.relationship == 'hijo_a':
                    parentesco = 'Hija'
                if i.relationship == 'padre/madre':
                    parentesco = 'Madre'
                if i.relationship == 'concubino_a':
                    parentesco = 'Concubina'
            else:
                genero = 'Masculino'
                if i.relationship == 'esposo_a':
                    parentesco = 'Esposo'
                if i.relationship == 'hijo_a':
                    parentesco = 'Hijo'
                if i.relationship == 'padre/madre':
                    parentesco = 'Padre'
                if i.relationship == 'concubino_a':
                    parentesco = 'Concubino'
            
            if i.hcm == True:
                hcm = 'Si'
            else:
                hcm = ""
                
            if i.seg_vida == True:
                seg_vida = 'Si'
            else:
                seg_vida = ""
            
            if i.identification_id == "0":
                cedula = ""
            else:
                cedula = i.identification_id
            
            lista.append((i.name, cedula, genero, parentesco, i.edad, hcm, seg_vida))
            lista.sort()
            
        return lista
    
    
family_report_wizard()
